import uuid

from sqlalchemy import ForeignKey, UniqueConstraint, text
from sqlalchemy.dialects.postgresql import UUID
from sqlalchemy.orm import Mapped, mapped_column

from ..db.base_class import reg


@reg.mapped_as_dataclass(unsafe_hash=True)
class RolePermission:
    __tablename__ = "role_permissions"
    __table_args__ = (UniqueConstraint("permission_id", "role_id"),)
    id: Mapped[uuid.UUID] = mapped_column(
        "id", UUID(as_uuid=True), primary_key=True, server_default=text("gen_random_uuid()"), insert_default=uuid.uuid4
    )
    permission_id: Mapped[uuid.UUID] = mapped_column(
        "permission_id",
        UUID(as_uuid=True),
        ForeignKey("permissions.id"),
        nullable=False,
    )
    role_id: Mapped[uuid.UUID] = mapped_column("role_id", UUID(as_uuid=True), ForeignKey("roles.id"), nullable=False)
