import uuid

from pydantic import BaseModel, Field


class SectionIn(BaseModel):
    name: str = Field(..., min_length=1)

    class Config:
        anystr_strip_whitespace = True


class Section(SectionIn):
    id_: uuid.UUID

    class Config:
        anystr_strip_whitespace = True
        fields = {"id_": "id"}


class SectionBlank(BaseModel):
    name: str

    class Config:
        anystr_strip_whitespace = True


class SectionLink(BaseModel):
    id_: uuid.UUID = Field(...)
    name: str | None

    class Config:
        fields = {"id_": "id"}
