from pydantic import BaseModel, Field

from . import to_camel
from .printer import PrinterLink
from .sale_category import SaleCategoryLink


class SectionPrinter(BaseModel):
    sale_category: SaleCategoryLink | None
    printer: PrinterLink | None
    copies: int = Field(ge=0)

    class Config:
        alias_generator = to_camel
