import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';

import { ModifierCategory } from '../../core/modifier-category';

import { ModifierCategoryListDatasource } from './modifier-category-list-datasource';

@Component({
  selector: 'app-modifier-category-list',
  templateUrl: './modifier-category-list.component.html',
  styleUrls: ['./modifier-category-list.component.css'],
})
export class ModifierCategoryListComponent implements OnInit {
  list: ModifierCategory[] = [];
  dataSource: ModifierCategoryListDatasource = new ModifierCategoryListDatasource(this.list);
  /** Columns displayed in the table. Columns IDs can be added, removed, or reordered. */
  displayedColumns = ['name', 'minimum', 'maximum', 'products', 'isActive'];

  constructor(private route: ActivatedRoute) {}

  ngOnInit() {
    this.route.data.subscribe((value) => {
      const data = value as { list: ModifierCategory[] };
      this.list = data.list;
    });
    this.dataSource = new ModifierCategoryListDatasource(this.list);
  }
}
