import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot, Resolve } from '@angular/router';
import { Observable } from 'rxjs';

import { SaleCategory } from '../core/sale-category';

import { SaleCategoryService } from './sale-category.service';

@Injectable({
  providedIn: 'root',
})
export class SaleCategoryResolver implements Resolve<SaleCategory> {
  constructor(private ser: SaleCategoryService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<SaleCategory> {
    const id = route.paramMap.get('id');
    return this.ser.get(id);
  }
}
