import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot, Resolve, Router } from '@angular/router';
import { Observable } from 'rxjs';

import { Product } from '../../core/product';
import { ProductService } from '../../product/product.service';

@Injectable({
  providedIn: 'root',
})
export class ProductsResolver implements Resolve<Product[]> {
  constructor(private ser: ProductService, private router: Router) {}

  resolve(route: ActivatedRouteSnapshot): Observable<Product[]> {
    const id = route.paramMap.get('id') as string;
    return this.ser.listIsActiveOfCategory(id);
  }
}
