import { Component, Inject } from '@angular/core';
import { FormArray, FormControl, FormGroup } from '@angular/forms';
import { MAT_DIALOG_DATA, MatDialogRef } from '@angular/material/dialog';
import { Observable } from 'rxjs';

@Component({
  selector: 'app-split-bill',
  templateUrl: './split-bill.component.html',
  styleUrls: ['./split-bill.component.css'],
})
export class SplitBillComponent {
  list: { id: string; name: string; selected: boolean }[] = [];
  form: FormGroup<{
    saleCategories: FormArray<
      FormGroup<{
        saleCategory: FormControl<boolean>;
      }>
    >;
  }>;

  constructor(
    public dialogRef: MatDialogRef<SplitBillComponent>,
    @Inject(MAT_DIALOG_DATA)
    public data: Observable<{ id: string; name: string; selected: boolean }[]>,
  ) {
    this.form = new FormGroup({
      saleCategories: new FormArray<
        FormGroup<{
          saleCategory: FormControl<boolean>;
        }>
      >([]),
    });
    this.data.subscribe((list: { id: string; name: string; selected: boolean }[]) => {
      this.list = list;
      this.form.controls.saleCategories.clear();

      this.list.forEach((x) =>
        this.form.controls.saleCategories.push(
          new FormGroup({
            saleCategory: new FormControl(x.selected, { nonNullable: true }),
          }),
        ),
      );
    });
  }

  accept(): void {
    const array = this.form.controls.saleCategories;
    this.list.forEach((item, index) => {
      item.selected = array.controls[index].value.saleCategory ?? false;
    });
    this.dialogRef.close(this.list);
  }
}
