import { DataSource } from '@angular/cdk/collections';
import { Observable } from 'rxjs';
import { tap } from 'rxjs/operators';

import { SettleOption } from '../../core/settle-option';

export class SettleOptionListDatasource extends DataSource<SettleOption> {
  private data: SettleOption[] = [];

  constructor(private readonly dataObs: Observable<SettleOption[]>) {
    super();
    this.dataObs = dataObs.pipe(
      tap((x) => {
        this.data = x;
      }),
    );
  }

  connect(): Observable<SettleOption[]> {
    return this.dataObs;
  }

  disconnect() {}
}
