import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot, Resolve } from '@angular/router';
import { Observable } from 'rxjs';

import { UpdateProductPrices } from './update-product-prices';
import { UpdateProductPricesService } from './update-product-prices.service';

@Injectable({
  providedIn: 'root',
})
export class UpdateProductPricesResolver implements Resolve<UpdateProductPrices> {
  constructor(private ser: UpdateProductPricesService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<UpdateProductPrices> {
    const date = route.queryParamMap.get('date') ?? null;
    const id = route.paramMap.get('id');
    return this.ser.get(id, date);
  }
}
